"""add scheduling constraints and objectives

Revision ID: d3ffa75fb9e5
Revises: 37d0111fadb3
Create Date: 2024-08-28 18:27:43.763827

"""
from alembic import op
import sqlalchemy as sa

from ryax.common.domain.registration.registration_values import SiteType, NodeArchitecture
from ryax.common.infrastructure.database.scalarEnumListType import ScalarEnumListType

# revision identifiers, used by Alembic.
revision = 'd3ffa75fb9e5'
down_revision = '37d0111fadb3'
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('scheduling_constraints',
    sa.Column('workflow_action_id', sa.String(), nullable=False),
    sa.Column('site_type_list', ScalarEnumListType(SiteType), nullable=False, server_default=""),
    sa.Column('arch_list', ScalarEnumListType(NodeArchitecture), nullable=False, server_default=""),
    sa.ForeignKeyConstraint(['workflow_action_id'], ['workflow_action.id'], ),
    sa.PrimaryKeyConstraint('workflow_action_id')
    )
    op.create_table('scheduling_objectives',
    sa.Column('energy', sa.Float(), nullable=True),
    sa.Column('performance', sa.Float(), nullable=True),
    sa.Column('cost', sa.Float(), nullable=True),
    sa.Column('workflow_action_id', sa.String(), nullable=False),
    sa.Column('objective_score_id', sa.String(), nullable=True),
    sa.ForeignKeyConstraint(['objective_score_id'], ['objective_score.id'], ),
    sa.ForeignKeyConstraint(['workflow_action_id'], ['workflow_action.id'], ),
    sa.PrimaryKeyConstraint('workflow_action_id')
    )
    op.create_table('nodepool_constraints_association',
    sa.Column('node_pool', sa.String(), nullable=True),
    sa.Column('constraint', sa.String(), nullable=True),
    sa.ForeignKeyConstraint(['constraint'], ['scheduling_constraints.workflow_action_id'], ),
    sa.ForeignKeyConstraint(['node_pool'], ['node_pools.id'], )
    )
    op.create_table('site_constraints_association',
    sa.Column('site', sa.String(), nullable=True),
    sa.Column('constraint', sa.String(), nullable=True),
    sa.ForeignKeyConstraint(['constraint'], ['scheduling_constraints.workflow_action_id'], ),
    sa.ForeignKeyConstraint(['site'], ['sites.id'], )
    )
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_table('site_constraints_association')
    op.drop_table('nodepool_constraints_association')
    op.drop_table('scheduling_objectives')
    op.drop_table('scheduling_constraints')
    # ### end Alembic commands ###
